unit FTPForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdFTP, StdCtrls, IdAntiFreezeBase, IdAntiFreeze;

type
  TFTPProgressForm = class(TForm)
    FTPControl: TIdFTP;
    ProgressBar: TProgressBar;
    DoItBtn: TButton;
    IdAntiFreeze1: TIdAntiFreeze;
    procedure FTPControlWork(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCount: Integer);
    procedure FTPControlWorkBegin(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCountMax: Integer);
    procedure DoItBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FTPProgressForm: TFTPProgressForm;

const
  source =  '\home\dunit\dist\dunit-3.2.6.2.zip';
  dest   =  'anonymous:juanco.users.sourceforge.net'
          + '@upload.sourceforge.net:incoming/';

type
  TFTPFileRec = record
    url   :string;
    user  :string;
    pwd   :string;
    host  :string;
    path  :string;
  end;


implementation
uses
  JclStrings;

{$R *.DFM}

function parseFileURL(url :string) :TFTPFileRec;
var
 p :Integer;
begin
   result.url := url;
   p := pos('@', url);
   if p <= 0 then
   begin
     result.user := '';
     result.pwd  := '';
   end
   else begin
     result.user := copy(url, 1, p-1);
     url         := copy(url, p+1, length(url));
     p := pos(':', result.user);
     if p >= 0 then
     begin
       result.pwd  := copy(result.user, p+1, length(result.user));
       result.user := copy(result.user, 1, p-1);
     end;
   end;
   p := pos(':', url);
   if p <= 0 then
     result.host := ''
   else begin
     result.host := copy(url, 1, p-1);
     url         := copy(url, p+1, length(url));
   end;
   result.path := url;
end;


procedure TFTPProgressForm.FTPControlWork(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCount: Integer);
begin
  if AWorkMode = wmRead then
  begin
     ProgressBar.Position := AWorkCount;
  end;
end;

procedure TFTPProgressForm.FTPControlWorkBegin(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCountMax: Integer);
begin
  if AWorkMode = wmRead then
  begin
     ProgressBar.Position := 0;
     ProgressBar.Max := AWorkCountMax;
  end;
end;

procedure TFTPProgressForm.DoItBtnClick(Sender: TObject);
var
  src   :TFTPFileRec;
  dst   :TFTPFileRec;
  dir   :string;
  fname :string;
begin
  src := parseFileURL(source);
  dst := parseFileURL(dest);

  if dst.path[length(dst.path)] = '/' then
  begin
    dir   := copy(dst.path, 1, length(dst.path)-1);
    fname := ExtractFileName(src.path);
  end
  else begin
       dir   := ExtractFilePath(dst.path);
       fname := ExtractFileName(dst.path);
  end;

  FTPControl.Host     := dst.host;
  FTPControl.User     := dst.user;
  FTPControl.Password := dst.pwd;
  FTPControl.Connect(true);
  try
    if dir <> '' then
      FTPControl.ChangeDir(dir);
    FTPControl.Put(src.path, fname, false);
  finally
    FTPControl.Disconnect;
  end;
end;

end.
